import java.math.*;
import java.util.*;

public class PrimeGen
{
  public static ArrayList<BigInteger> generate(BigInteger p, BigInteger n)
  {
    BigInteger t = new BigInteger("2");
    ArrayList<BigInteger> result = new ArrayList<BigInteger>(); 
    for (;t.compareTo(n) < 0; t = t.add(BigInteger.ONE)) {
      if (t.isProbablePrime(10) && ModSqrt.isQR(p, t)) {
        result.add(t);
      }    
    } 
    return result;
  }
}
